Subject: Re: Bug#642: Changes in X2Go Client for Windows to enable it conform to Visual Studio's stricter type checking

From: Michael DePaulo <[email-masked]>
Date: Wed, 3 Dec 2014 00:27:45 -0500

Hi George, see below

On Tue, Dec 2, 2014 at 6:48 PM, George Trakatelis <[email-masked]> wrote:
>
> Hi Michael,
>
> I built x2goclient 4.0.3.0 with MSVC2010's nmake.
> Unfortunately couldn't do so with Visual Studio 2010 IDE.
>
> > I have made a lot of progress, but I am having trouble finding a build
> > of libssh that includes the .lib file(s), and that is new enough. I
> > think the .lib file(s) are specific to MSVC.
>
> I attach a release build of libssh 0.6.3 (please rename .doc to .zip).
> The sources are from libssh-0.6.3-762055b-pageant-support-mingw482.src.zip
> with a minor patch to enable libssh compile under MSVC2010.
>
Please share that patch. When I try to "generate" the VS2010 project
files under CMake 3.0.2, I get these 2 errors:

You have called ADD_LIBRARY for library ssh_threads_shared without any
source files. This typically indicates a problem with your
CMakeLists.txt file

CMake Error: CMake can not determine linker language for target:
ssh_threads_shared

I've attached the log from CMake.

> > The 0.5.0 win32 build that includes the .lib file appears to be too old
>
> I'm not aware of the build you are referring to.
>
It doesn't matter anymore, but I was referring to this:
http://www.libssh.org/files/win32/0.5/
Which is linked to from here:
http://www.libssh.org/get-it/

> > I get this error during compile:
> > .\sshmasterconnection.cpp(297) : error C3861:
> > 'ssh_channel_accept_forward': identifier not found
>
> That seems to be a missing function declaration from libssh.h.
> Apparently, something like
> ...
> LIBSSH_API ssh_channel ssh_channel_accept_forward(ssh_session session, int
> timeout_ms, int *destination_port);
> ...
> is missing.
>
It sounds like libssh 0.5 is too old. Let's not worry about it since
we have 0.6.3 working.

>
> Please let me know if the attached ssh.lib (for compiling) and ssh.dll (for
> runtime) are ok.
>
They work :) I had to copy over the .h files,  but that took me
minimal time. Please share the aforementioned patch though.

> George

I committed an update to the x2goclient changelog. This bug should be
marked as fixed based on that commit.

Also, I am keeping rough notes on how to compile X2Go Client under VS2010 here:
https://docs.google.com/spreadsheets/d/1F5cVkCesXzTlo4oDJrGTdVFB074kkY-5q5-hgJUiXr4/edit?usp=sharing

Think of that as the delta against the MinGW instructions:
http://wiki.x2go.org/doku.php/wiki:development:build-howto-mswin:x2goclient

-Mike